Subject: Re: [PATCH] run-command: detect finished children by closed pipe rather than waitpid

From: Johannes Sixt <[email-masked]>
Date: Wed, 11 Nov 2015 21:48:32 +0100

Am 11.11.2015 um 21:37 schrieb Stefan Beller:
> including the list and all others this time.
>
>>>                          if (code < 0) {
>>>                                  pp->shutdown = 1;
>>> -                               kill_children(pp, SIGTERM);
>>> +                               kill_children(pp, -code);
>>
>>
>> I'll see what this means for our kill emulation on Windows. Currently, we
>> handle only SIGTERM.
>
> So currently we only pass in SIGTERM from the callers, and I certainly
> only intend
> to use that signal. I just thought special casing the SIGTERM signal
> would do no good
> in terms of design here.
>
> So maybe that was not the right thought and we do have to special case
> SIGTERM here?

I wonder why task_finish() callback gets to choose a signal. The point 
here is, IIUC, when one child dies, the others must be halted, too. 
SIGTERM seems to be the only sensible choice.

-- Hannes